	local scvar = CV_RegisterVar({
	name = "sc_nodrain",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
	})

	local scrvar = CV_RegisterVar({
	name = "sc_ringlimit",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
	})
	
	COM_AddCommand("solclash", function(player)
		if (skins["blaze"] == nil and skins["marine"] == nil)
		CONS_Printf(player, "you can't use this right now")
		return end 
			if (player.solchar == nil)
			CONS_Printf(player, "you can't use sol transformations")
			return end
				if (player.mo.skin == "blaze" or player.mo.skin == "marine")
				CONS_Printf(player, "you can't use this command since you're blaze/marine")
				return end
					if (player.solchar)
					and (player.iratherusesol == false)
					player.iratherusesol = true
					CONS_Printf(player, "you now use your sol transformation instead")
					elseif (player.solchar)
					and (player.iratherusesol == true)
					player.iratherusesol = false
					CONS_Printf(player, "you use your super transformation instead")
			end
	end)
	
	COM_AddCommand("mysticsuperclash", function(player)
		if (player.spectator)
		CONS_Printf(player, "you can't use this right now, be ingame first")
		return end
			if (player.mo and player.mo.valid and player.mo.skin == "marine" or player.mo.skin == "blaze")
			CONS_Printf(player, "you can't use this as blaze/marine.")
			return end
				if (player.mo.skin == "sms")
				CONS_Printf(player, "you're trying to go as MSSMS, aren't you?")
				return end
					if (player.iratherusesol)
					CONS_Printf(player, "you no longer use sol and use mystic super")
					player.iratherusesol = false
					player.ilikesms = 1
					elseif (player.ilikesms == 1)
					player.ilikesms = 0
					CONS_Printf(player, "you no longer use mystic super")
					elseif not (player.iratherusesol and player.ilikesms)
					player.ilikesms = 1
					CONS_Printf(player, "you now use sms' powershare form, mystic super instead of super")
			end
	end)
	
	COM_AddCommand("darkclash", function(player)
		if (player.darkform == nil)
		CONS_Printf(player, "you can't use this right now")
		return end 
			if (player.mo.skin == "blaze" or player.mo.skin == "marine")
			CONS_Printf(player, "you can't use this command since you're blaze/marine")
			return end
				if (player.mo.skin == "sms" or player.mo.skin == "samus")
				CONS_Printf(player, "you can't use this command since you're SMS/samus")
				return end
					if (player.darkform)
					and (player.edgyform == false)
					player.edgyform = true
					CONS_Printf(player, "you now use your dark form instead")
					elseif (player.darkform)
					and (player.edgyform == true)
					player.edgyform = false
					CONS_Printf(player, "you use your super form again")
			end
	end)
	
	COM_AddCommand("togglesupersprites", function(player)
		if (player.mo and player.mo.valid)
		and not (player.mo.eflags & MFE_FORCENOSUPER)
		player.mo.eflags = $ | MFE_FORCENOSUPER
		CONS_Printf(player, "you no longer use your super sprites!")
		elseif (player.mo.eflags & MFE_FORCENOSUPER)
		and (player.mo and player.mo.valid)
		player.mo.eflags = $ & ~MFE_FORCENOSUPER
		CONS_Printf(player, "you now use your super sprites.")
		end
	end)
	
	COM_AddCommand("sc_hud", function(player)
		if (player.schud == true)
		CONS_Printf(player, "the hud has been turned off.")
		player.schud = false
		elseif (player.schud == false)
		player.schud = true
		CONS_Printf(player, "the hud has been turned back on.")
		end
	end)
	
	addHook("PlayerThink", function(player)
		if not (gametype == GT_SCLASH or gametype == GT_TSCLASH or gametype == GT_SCLASHE) return end
		
		if (scrvar.value == 1 and player.rings >= 201)
		and not (player.mo.skin == "sms")
		player.rings = 200
		end
		
		if (player.rings >= 301 and player.mo.skin == "sms")
		player.rings = 300
		end
		
		if (player.mo ~= nil and player.mo.skin == "inazuma" and player.inazuma ~= nil and Silverhorn ~= nil and Silverhorn.Inazuma ~= nil and Silverhorn.Inazuma.IsUltimate(player))
		and (leveltime % TICRATE == 0)
		P_GivePlayerRings(player, -1)
			if (scvar.value == 1)
			P_GivePlayerRings(player, -2)
			end
		end
		
		if (player.mo ~= nil and player.mo.skin == "inazuma" and player.inazuma ~= nil and Silverhorn ~= nil and Silverhorn.Inazuma ~= nil and player.inazuma.flags & Silverhorn.Inazuma.FLAGS.TRANSFORMING) 
		and (leveltime % TICRATE == 0 and scvar.value == 1)
		P_GivePlayerRings(player, -1)
		end 
		//now that thats done I can go do other things
		if (scvar.value == 1 and leveltime % TICRATE == 0 and player.powers[pw_super])  or (scvar.value == 1 and leveltime % TICRATE == 0 and player.solchar and player.solchar.istransformed >= 1) or (scvar.value == 1 and leveltime % TICRATE == 0 and player.mysticsuper)
		P_GivePlayerRings(player, 1)
		end
		
		if (solchars == nil)
		player.iratherusesol = false
		end
		
		if (player.mo ~= nil and player.mo.valid and solchars ~= nil)
		and not (solchars[player.mo.skin])
		player.iratherusesol = false
		end
		
		if (player.schud == nil)
		player.schud = true
		end
		
		if (player.solemeralds ~= nil)
		player.solemeralds = 127
		end
		
		if (player.sc_darkuncolorize == nil)
		player.sc_darkuncolorize = false
		end
		
		if (player.adrenaline ~= nil)
		and (scvar.value == 1 and leveltime % TICRATE == 0 and player.darkform and player.darkform.on == true)
		player.adrenaline = $ + 1
		end
		
		if (player.rings >= 100)
		and (player.edgyform and player.darkform)
		player.superdark = true
		elseif (player.rings < 100)
		player.superdark = false
		end
		
		if (player.sc_darkuncolorize == false and player.edgyform and player.darkform)
		and (player.mo.valid and player.superdark == false)
		player.sc_darkuncolorize = true
		player.mo.colorized = false
		elseif (player.sc_darkuncolorize == true and player.edgyform and player.darkform)
		and (player.mo.valid and player.superdark == true)
		player.sc_darkuncolorize = false
		player.mo.colorized = true
		end
	end)
	
	//man
	//I do not care about secrets anymor
	//wac
	
	//solstuff section! this took way longer than I thought it would!
	//just in case I'd need to
	//also, since there's a tutorial anyway, I figured I'd write the same exact tutorial to do the same thing.
	//example:
	//1 = sol only
	//2 = sol and super
	//3 = sol and super, except no sol color 
	//
	//solchars["exampleskin"] ={SKINCOLOR_YOURSUPERCOLOR1, 2}
	//
	//alright I think it's time to go work on v3.
	//nvm
	//also I don't think I'll need this anymore
	//if not solchars
		//rawset(_G, "solchars", {})
	//end
	

	addHook("PlayerSpawn", function(player)
		if not (gametype == GT_SCLASH or gametype == GT_TSCLASH or gametype == GT_SCLASHE)
		return end
		if (player.spectator)
		return end
		local allineedtodoistransformandcircletheemeraldswhy = {
		istransformed = 0,
		emeraldcircle = 0,
		burningcolor = 1,
		bcolordirection = 1,
		spindown = false,
		jumpdown = false,
		earlyburncancel = false,
		solexception = false,
		musicplaying = 0
		}
		player.solchar = allineedtodoistransformandcircletheemeraldswhy
		if not (player.iratherusesol or player.mo.skin == "marine" or player.mo.skin == "blaze")
		player.solchar = nil
		end
	end)